@echo off
setlocal

call :Echo.Color.Init

goto main

:Echo.Color %1=Color %2=Str [%3=/n]
setlocal enableDelayedExpansion
set "str=%~2"
:Echo.Color.2
:# Replace path separators in the string, so that the final path still refers to the current path.
set "str=a%ECHO.DEL%!str:\=a%ECHO.DEL%\..\%ECHO.DEL%%ECHO.DEL%%ECHO.DEL%!"
set "str=!str:/=a%ECHO.DEL%/..\%ECHO.DEL%%ECHO.DEL%%ECHO.DEL%!"
set "str=!str:"=\"!"
:# Go to the script directory and search for the trailing -
pushd "%ECHO.DIR%"
findstr /p /r /a:%~1 "^^-" "!str!\..\!ECHO.FILE!" nul
popd
:# Remove the name of this script from the output. (Dependant on its length.)
for /l %%n in (1,1,12) do if not "!ECHO.FILE:~%%n!"=="" <nul set /p "=%ECHO.DEL%"
:# Remove the other unwanted characters "\..\: -"
<nul set /p "=%ECHO.DEL%%ECHO.DEL%%ECHO.DEL%%ECHO.DEL%%ECHO.DEL%%ECHO.DEL%%ECHO.DEL%"
:# Append the optional CRLF
if not "%~3"=="" echo.
endlocal & goto :eof

:Echo.Color.Var %1=Color %2=StrVar [%3=/n]
if not defined %~2 goto :eof
setlocal enableDelayedExpansion
set "str=!%~2!"
goto :Echo.Color.2

:Echo.Color.Init
set "ECHO.COLOR=call :Echo.Color"
set "ECHO.DIR=%~dp0"
set "ECHO.FILE=%~nx0"
set "ECHO.FULL=%ECHO.DIR%%ECHO.FILE%"
:# Use prompt to store a backspace into a variable. (Actually backspace+space+backspace)
for /F "tokens=1 delims=#" %%a in ('"prompt #$H# & echo on & for %%b in (1) do rem"') do set "ECHO.DEL=%%a"
goto :eof

:main
cls
echo MagAlpha EVK Factory Testing Tool
echo =================================
echo Reading values from MagAlpha EVK...
setlocal EnableDelayedExpansion
set lf=@
for /F "delims=" %%i in ('maread -s5 -xd -oc 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out: =%
for /f "tokens=1-5 delims=@" %%a in ("%out%") do set data1=%%a&set data2=%%b&set data3=%%c&set data4=%%d&set data5=%%e
for /f "tokens=2,3 delims=," %%a in ("%data1%") do set data1.val=%%a&set data1.index=%%b
for /f "tokens=2,3 delims=," %%a in ("%data2%") do set data2.val=%%a&set data2.index=%%b
for /f "tokens=2,3 delims=," %%a in ("%data3%") do set data3.val=%%a&set data3.index=%%b
for /f "tokens=2,3 delims=," %%a in ("%data4%") do set data4.val=%%a&set data4.index=%%b
for /f "tokens=2,3 delims=," %%a in ("%data5%") do set data5.val=%%a&set data5.index=%%b
if not "%out:ftdi=%"=="%out%" (
   echo echo|set /p=MagAlpha read test		[
   call :Echo.Color 0c "FAILED"
   echo ]
   echo No device connected.
   pause
   goto :eof
) 
set /a avgval=(%data1.val%+%data2.val%+%data3.val%+%data4.val%+%data5.val%)/5
echo MagAlpha EVK detected.
set /a diff1=%data1.val%-%avgval%&set /a diff2=%data2.val%-%avgval%&set /a diff3=%data3.val%-%avgval%&set /a diff4=%data4.val%-%avgval%&set /a diff5=%data5.val%-%avgval%
if %diff1% gtr 5000 set unstable=1
if %diff2% gtr 5000 set unstable=1
if %diff3% gtr 5000 set unstable=1
if %diff4% gtr 5000 set unstable=1
if %diff5% gtr 5000 set unstable=1
echo echo|set /p=MagAlpha read test			[
set failed=0
if "%data1.index%"=="%data2.index%" (call :Echo.Color 0c "FAILED"&set failed=1)
if "%unstable%"=="1" if "%failed%"=="0" (call :Echo.Color 0e "UNSTABLE")
if not "%unstable%"=="1" if "%failed%"=="0"  (call :Echo.Color 0a "PASSED")
echo ]

echo Writing register configurations...
set passed=&set failed=0
set out=
mareg -w 0=0xff
for /F "delims=" %%i in ('mareg -r 0 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if not "%out%"=="11111111" (set failed=1)
set out=
mareg -w 0=0x00
for /F "delims=" %%i in ('mareg -r 0 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if "%failed%"=="0" if "%out%"=="00000000" (set passed=1)
echo echo|set /p=Register 0 write test			[
if "%passed%"=="1" (call :Echo.Color 0a "PASSED")
if not "%passed%"=="1" (call :Echo.Color 0c "FAILED")
echo ]

set passed=&set failed=0
set out=
mareg -w 3=0xff
for /F "delims=" %%i in ('mareg -r 3 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if not "%out%"=="11111111" (set failed=1)
set out=
mareg -w 3=0x00
for /F "delims=" %%i in ('mareg -r 3 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if "%failed%"=="0" if "%out%"=="00000000" (set passed=1)
echo echo|set /p=Register 3 write test			[
if "%passed%"=="1" (call :Echo.Color 0a "PASSED")
if not "%passed%"=="1" (call :Echo.Color 0c "FAILED")
echo ]

set passed=&set failed=0
set out=
mareg -w 4=0xff
for /F "delims=" %%i in ('mareg -r 4 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if not "%out%"=="11111111" (set failed=1)
set out=
mareg -w 4=0x00
for /F "delims=" %%i in ('mareg -r 4 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if "%failed%"=="0" if "%out%"=="00000000" (set passed=1)
echo echo|set /p=Register 4 write test			[
if "%passed%"=="1" (call :Echo.Color 0a "PASSED")
if not "%passed%"=="1" (call :Echo.Color 0c "FAILED")
echo ]

set passed=&set failed=0
set out=
mareg -w 5=0xff
for /F "delims=" %%i in ('mareg -r 5 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if not "%out%"=="11111111" (set failed=1)
set out=
mareg -w 5=0x00
for /F "delims=" %%i in ('mareg -r 5 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if "%failed%"=="0" if "%out%"=="00000000" (set passed=1)
echo echo|set /p=Register 5 write test			[
if "%passed%"=="1" (call :Echo.Color 0a "PASSED")
if not "%passed%"=="1" (call :Echo.Color 0c "FAILED")
echo ]

set passed=&set failed=0
set out=
mareg -w 7=0xff
for /F "delims=" %%i in ('mareg -r 7 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if not "%out%"=="11111111" (set failed=1)
set out=
mareg -w 7=0x00
for /F "delims=" %%i in ('mareg -r 7 2>nul') do if ("!out!"=="") (set out=%%i) else (set out=!out!%lf%%%i)
set out=%out:~-8%
if "%failed%"=="0" if "%out%"=="00000000" (set passed=1)
echo echo|set /p=Register 7 write test			[
if "%passed%"=="1" (call :Echo.Color 0a "PASSED")
if not "%passed%"=="1" (call :Echo.Color 0c "FAILED")
echo ]

echo.
pause
exit /b

:# The following line must be last and not end by a CRLF.
-